<template>
  <v-container>
    <v-quagga
      :onDetected="logIt"
      :readerSize="readerSize"
      :readerTypes="readers"
    ></v-quagga>
    <div class="products-barcode">
      <button id="barcode-scanner" v-on:click="runQuagga">
        Turn on barcode
      </button>
    </div>
  </v-container>
</template>

<style>
#barcode-scanner canvas.drawingBuffer,
#barcode-scanner video.drawingBuffer {
  display: none;
}
#barcode-scanner canvas,
#barcode-scanner video {
  width: 100%;
  height: auto;
}
</style>

<script>
import Quagga from "quagga";
export default {
  data() {
    return {
      readers: [
        "ean_reader",
        "ean_8_reader",
        "code_39_reader",
        "code_39_vin_reader",
        "codabar_reader",
        "upc_reader",
        "upc_e_reader"
      ]
    };
  },
  created() {},
  mounted() {},

  methods: {
    runQuagga: function() {
      Quagga.init(
        {
          inputStream: {
            name: "Live",
            type: "LiveStream",
            numOfWorkers: navigator.hardwareConcurrency,
            target: document.querySelector("#barcode-scanner")
          },
          decoder: {
            readers: ["upc_reader"]
          }
        },
        function(err) {
          if (err) {
            console.log(err);
            return;
          }
          Quagga.initialized = true;
          Quagga.start();
        }
      );
      if (
        "#barcode-scanner".length > 0 &&
        navigator.mediaDevices &&
        typeof navigator.mediaDevices.getUserMedia === "function"
      ) {
        var last_result = [];
        if (Quagga.initialized == undefined) {
          Quagga.onDetected(function(result) {
            var last_code = result.codeResult.code;
            last_result.push(last_code);
            if (last_result.length > 5) {
              var counts = {};
              last_result.forEach(function(value) {
                if (!counts[value]) {
                  counts[value] = 0;
                }
                counts[value]++;
              });
              console.log(counts);
              Quagga.stop();

              console.log(
                counts.sort(function(a, b) {
                  return a - b;
                })
              );
              return counts;
            }
            console.log(counts);
            // console.log(counts)
            // counts.forEach(function(){
            // });
            // console.log(last_code)
            // if (last_result.length > 20) {
            //   code = orderByOccurrence(last_result)[0];
            //   last_result = [];
            //   Quagga.stop();
            // below should be an axios post call
            // $.ajax({
            //   type: "POST",
            //   url: '/products/get_barcode',
            //   data: { upc: code }
            // });
            // }
          });
        }
      }
    },
    orderByOccurrence: function(arr) {
      var counts = {};
      arr.forEach(function(value) {
        if (!counts[value]) {
          counts[value] = 0;
        }
        counts[value]++;
      });
    },
    startQuagga: function() {
      Quagga.init(
        {
          inputStream: {
            name: "Live",
            type: "LiveStream",
            numOfWorkers: navigator.hardwareConcurrency,
            target: document.querySelector("#barcode-scanner")
          },
          decoder: {
            readers: [
              "ean_reader",
              "ean_8_reader",
              "code_39_reader",
              "code_39_vin_reader",
              "codabar_reader",
              "upc_reader",
              "upc_e_reader"
            ]
          }
        },
        function(err) {
          if (err) {
            console.log(err);
            return;
          }
          Quagga.initialized = true;
          Quagga.start();
        }
      );
    },
    findBarcodes: function() {
      if (
        "#barcode-scanner".length > 0 &&
        navigator.mediaDevices &&
        typeof navigator.mediaDevices.getUserMedia === "function"
      ) {
        var last_result = [];
        if (Quagga.initialized == undefined) {
          Quagga.onDetected(function(result) {
            var last_code = result.codeResult.code;
            last_result.push(last_code);
            if (last_result.length > 20) {
              // code = orderByOccurrence(last_result)[0];
              last_result = [];
              Quagga.stop();
              // below should be an axios post call
              // $.ajax({
              //   type: "POST",
              //   url: '/products/get_barcode',
              //   data: { upc: code }
              // });
            }
          });
        }
      }
    }
  }
};
</script>
